mrrl

Minimal Reliable Reproducible Linux
git clone https://ccx.te2000.cz/git/mrrl
Log | Files | Refs | Submodules | README

nawk (5223B)


      1 #!/usr/bin/env pthbs-build
      2 #+busybox.504428034e649f598212c8994966e36667178683ec90987355f495ad3ca4abac
      3 #+busybox-bzip2.4ea548a271f41e7147568dc02e5071fb200eab38a9a22e733d3106b71e354812
      4 #+busybox-gzip.0999e8c6a8b7df82fc1cf10ade2468fb2bc4352f76d4b1d2af5099a65ccada9b
      5 #+busybox-lzop.f0d93621bfd8ca106a8590562d93158b05087e5ef48068c7a84d9967b67d2d25
      6 #+busybox-unzip.737f61aac20ef6c0554fca59bb599bf98e4fb77fbd97fba65a3692ac9d4afb84
      7 #+busybox-xz.639cf99dd37a7d6f719b937d13af92202e01adf11c130f8647574c1d9ef5b0d2
      8 #+busybox-cpio.d22266c2b6c056c0ea96873402d06591aa23368ea24d91f1fbf8a8327cb210f8
      9 #+busybox-dpkg.2b0dd2fa41e946e98f2f8948ae3d3a152a069c77460768d9c76d41f56974e514
     10 #+busybox-rpm.62bb242b4fbb3fd51b233ed9ce6c257ab997b1ee3a68ef3048656addc98f3d97
     11 #+busybox-tar.dd3d9b0075fc038df431ce2a16fc1b140de521e1aa6d154dc7b607f9403d5ac0
     12 #+busybox-ed.6ff6cd59168705c6b256d800cde7e8c69dd05c556520317dae6a0b492029fe6b
     13 #+busybox-sed.8793bcd2536ab32fa528bbb0c22f0c014663ac5e045193aa7bd113a07f58c5b9
     14 #+busybox-vi.db3d29c62845a55b7c5491d057cb9ea6c6deba93c567f4ef9eb15f06be8ad171
     15 #+busybox-xxd.9dff38f0c9dbf57856a0824bc23cc99cb31a67ce5138de7a6de2e255880a5696
     16 #+busybox-process-extra.448a35fa5362e576a23ef306ec6e0da2f625adae08cc5c3b12a01d5d28f76ce6
     17 #+busybox-procps.835712dc539d5583773d175255a5c4e27b5823d97e855948d27cc2c194247b0f
     18 #+busybox-psmisc.f2434b74cd3e07ddea335da52c222567bc111b621f0f060afef8bcc26a8d96fd
     19 #+busybox-ash.039eb4051853cdde4d03b8dbd5d6128957bf933be5ac398471666e5db0d33dab
     20 #+busybox-bc.e731e83c11906525d676777835256a3f478779eafe7152701adfc46558d73009
     21 #+busybox-coreutils.a57a12f85d58388c284d4f93f6c485d4bc2a7eac0d0f4be57b20d2ddbd4c8b8f
     22 #+busybox-coreutils-extra.09de38ce2d65026888577e8314766e4b17205b2a99a4fecfdd5cd89c1cd82aed
     23 #+busybox-daemontools.d12e277e7154028f0beaae44ad1e2c7e1cd12d28549b6861604fc634c3e09aaf
     24 #+busybox-grep.474abd8ddad6afb320c55141078cb4507d02c4610181a4d72a4d98ba93434a60
     25 #+busybox-misc.ea211db457ee098923eeff82a4388d5864254a6c2718f38471b5b2867c73d158
     26 #+busybox-sh.49a7505969c9882c8a9a7ad3f5dba6d1382add3559f4da21ceafb2708d3fd4c8
     27 #+busybox-util-linux-unpriv.95b792cd49d1f00d5488b15d93809166916ef3b8a63a69ea11f3bf6e92a74f24
     28 #+busybox-findutils.db22f512240124b15d61cf8d0ceafebc98649f6f137608a2d1bd66f18e81ad8c
     29 #+nawk.abe3790fd5e321ccd4e1ab7dab56339222e2eee686bc4b2241e7853104a4a500
     30 #+bison.101f9166d34a37221f88a74b20d14d9a10138f88e4b8195996de66d7fba93e2c
     31 #+musl-cross-make.4bca2cd43f4a72eaaeefc4befc0b0ce736a5906ec0245552a8db7dc56fa9e5ec
     32 #+gnu-make.fb4cff1c46827d02016d0f94d5256a263e7710025f7480fffb7580dc922a6069
     33 #@untar:-z:sha256:e031b1e1d2b230f276f975bffb923f0ea15f798c839d15a3f26a1a39448e32d7:.
     34 
     35 
     36 # - build script start -
     37 
     38 build_env_static() {
     39 	export CFLAGS="-ffile-prefix-map=${pthbs_workdir}=builddir $CFLAGS"
     40 	export CXXFLAGS="-ffile-prefix-map=${pthbs_workdir}=builddir $CXXFLAGS"
     41 	export LDFLAGS="-static -L$pthbs_build_environment/library $LDFLAGS"
     42 }
     43 
     44 check_static() {
     45 	local exe || true
     46 	exe=$pthbs_destdir'/home/ccx/versions'/$pthbs_package/$1
     47 	if ! test -f $exe; then
     48 		printf '%s\n' "Error: file '$1' doesn't exist!"
     49 		exit 1
     50 	fi
     51 	local interp_info || true
     52 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     53 	if test x '!=' "x$interp_info"; then
     54 		printf '%s\n' "Error: '$1' is a dynamic binary!"
     55 		exit 1
     56 	fi
     57 }
     58 
     59 prefix=/home/ccx/versions/$pthbs_package
     60 dest=${pthbs_destdir%/}${prefix}
     61 cd 'awk-20250116'
     62 
     63 
     64 build_env_static
     65 make -j${JOBS:-1} -l$((1+${JOBS:-1})) CC="gcc -static"
     66 
     67 install -Dm755 a.out "${dest}"/command/awk
     68 install -Dm644 awk.1 "${dest}"/man/man1/awk.1
     69 install -Dm644 LICENSE FIXES FIXES.1e README.md TODO -t "${dest}"/doc/
     70 
     71 
     72 
     73 check_static 'command'/awk
     74 
     75 
     76 
     77 cd "$pthbs_destdir/home/ccx/versions/$pthbs_package"
     78 find -type d -o -print | awk -F/ '
     79 BEGIN {x["./command/awk"]=1
     80 	x["./man/man1/awk.1"]=1
     81 }
     82 
     83 function r1(s) {
     84 	sub("^[.]/[^/]*", ".", s)
     85 	return s
     86 }
     87 function s1(repl, s) {
     88 	sub("^[.]/[^/]*", "./"repl, s)
     89 	return s
     90 }
     91 function link(src) {
     92 	x[$0]=0
     93 	printf "%s\t%s\n", $0, src
     94 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
     95 }
     96 $1!="."{exit 1}
     97 $2 == "env" { link($0); next }
     98 $2 == ".env-template" { link($0); next }
     99 
    100 $2 == "command" { link($0); next }
    101 $2 == "command" { link($0); next }
    102 $2 == "bin" { link(s1("command", $0)); next }
    103 $2 == "sbin" { link(s1("command", $0)); next }
    104 
    105 $2 == "library.so" { link($0); next }
    106 $2 == "library" { link($0); next }
    107 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
    108 $2 == "lib" && $NF ~ /\.so(\..*)?$/ { link(s1("library.so", $0)); next }
    109 
    110 $2 == "share" && $3 == "info" { link(s1("info", r1($0))); next }
    111 $2 == "share" && $3 == "man" { link(s1("man", r1($0))); next }
    112 $2 == "share" && $3 == "doc" { link(s1("doc", r1($0))); next }
    113 
    114 $2 == "config" { link($0); next }
    115 $2 == "man" { link($0); next }
    116 $2 == "info" { link($0); next }
    117 $2 == "doc" { link($0); next }
    118 $2 == "data" { link($0); next }
    119 $2 == "include" { link($0); next }
    120 
    121 
    122 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    123 
    124 END {
    125 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    126 	retcode = 0
    127 	for(fname in x) {
    128 		if(x[fname]) {
    129 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    130 			retcode = 3
    131 		}
    132 	}
    133 	exit retcode
    134 }' >.install-links.new
    135 mv .install-links.new .install-links
    136